#!/bin/bash
# Author: bert2002
# Homepage: http://www.pissflitsche.net/atiscript
# Datum: 09.02.2006
#trap "" 2 3
#trap "" SIGTSTP

#functions 	ati-8.16.20
#		ati-8.14.13 
#		ati-8.8.25 
#		ati-run 
#		ati-t
#		ati-menu
#		ati-make

function ati-t {

	version=0.0.8
	atifiles=http://www.pissflitsche.net/atiscript/files

	#ati-one-var -- READY 
	aone=Ati-8.16.20
	aonek=2.6.12

	#ati-two-var -- READY
	atwo=Ati-8.21.7
	atwok=2.6.15

	#ati-three-var -- READY
	athree=Ati-8.8.25
	athreek=2.6.10
	
	#ati-run-var -- READY
	afour="run-Installer"
	afourk=all

	if [ `id -un` != root ] 
	then 
		dialog --title "root access requirement" --backtitle "atiscript $version" --msgbox "       Please start the script as root" 5 50
		exit 0
	fi
	modprobe -r fglrx 2> /dev/null || echo "cannot unload fglrx - please wait"
	rm -rf /lib/modules/fglrx/ 2> /dev/null
	rm -rf ~/.atiscript/version 2> /dev/null
	if [ -d ~/.atiscript ] ; then
		touch ~/.atiscript/version 2>/dev/null
	else
		mkdir -p ~/.atiscript 2>/dev/null
		cd ~/.atiscript/
	fi
}

function ati-menu {
dialog --backtitle "atiscript $version" --checklist "Please choose a ati release Version:" 0 0 0 "$atwo" "at $atwok kernel" On "$aone" "at $aonek kernel" Off "$athree" "at $athreek kernel" Off "$afour" "at $afourk kernel" Off 2> ~/.atiscript/version
}



function ati-one {
filename=fglrx_6_8_0-8.16.20-1.i386.tar.gz
	
	cd ~/.atiscript/
	if [ -f $filename ] ; then
		echo "Okay: $filename"
		tar -xzf $filename && cd fglrx_6_8_0-8.16.20-1.i386
		cp -rf ./* / || echo "Error to copy files. Are you in X? Please leave it" || exit 1 
	else
		wget $atifiles/$filename || wget -c $atifiles/$filename
		tar -xzf $filename && cd fglrx_6_8_0-8.16.20-1.i386
		cp -rf ./* / || echo "Error to copy files. Are you in X? Please leave it" || exit 1 
	fi

}

function ati-two {
filename=fglrx_6_8_0-8.21.7-1.i386.tar.gz
patchset=drm_alloc_pages-2.6.15.patch

	cd ~/.atiscript/
	if [ -f $filename ] ; then
		echo "Okay: $filename"
	else
		wget $atifiles/$filename || wget -c $atifiles/$filename
	fi
		tar -xzf $filename && cd fglrx_6_8_0-8.21.7-1.i386
		cp -rf ./lib ./usr ./opt /
		cd /lib/modules/fglrx/build_mod && wget $atifiles/$patchset
		cd ../ && patch -p1 < build_mod/drm_alloc_pages-2.6.15.patch
		
}


function ati-three {
filename=fglrx_6_8_0-8.8.25-1.i386.tar.gz
patchset=8.8.25_patch.tar.gz

			cd ~/.atiscript/
			if [ -f $filename ] ; then
					echo "Okay: $filename"
					tar -xzf $filename && cd fglrx_6_8_0-8.8.25-1.i386
					cp -rf ./lib ./usr /
				else
					wget $atifiles/$filename || wget -c $atifiles/$filename
					tar -xzf $filename && cd fglrx_6_8_0-8.8.25-1.i386
					cp -rf ./lib ./usr /
			fi
			if [ -f $patchset ] ; then
					echo "Okay: $patchset"
					tar -xzf $patchset && cd ./8.8.25_patch
					cp 01-agpgart_be.c.patch /lib/modules/fglrx/build_mod/
					cp 02-agpgart_be.patch /lib/modules/fglrx/build_mod/
				else
					wget $atifiles/$patchset
					tar -xzf $patchset && cd ./8.8.25_patch
					cp 01-agpgart_be.c.patch /lib/modules/fglrx/build_mod/
					cp 02-agpgart_be.patch /lib/modules/fglrx/build_mod/
			fi
			cd /lib/modules/fglrx/build_mod/ 
			patch -p0 < 01-agpgart_be.c.patch 2> /dev/null
			patch -p0 < 02-agpgart_be.patch 2> /dev/null

}

function ati-make {
	cd /lib/modules/fglrx/build_mod/
	sh ./make.sh && cd .. && sh ./make_install.sh || exit 
}


function ati-run {
filename=ati-driver-installer-8.21.7-i386.run

	cd ~/.atiscript/
	if [ -f $filename ] ; then
		chmod a+x $filename && sh ./$filename
	else
		wget --no-check-certificate https://a248.e.akamai.net/f/674/9206/0/www2.ati.com/drivers/linux/$filename
		chmod a+x $filename && sh ./$filename
	fi

}

function ati-ready {
dialog --title "Installation final" --backtitle "atiscript $version" --msgbox "The installation is now finally and I hope all is installed correct. Please check:\n'cat /var/log/messages | grep fglx' \n            Good luck and visit: \n\n      www.pissflitsche.net/atiscript" 10 50
exit 0

}


####### Start
ati-t
ati-menu
if [ `cat ~/.atiscript/version` == "\"$aone"\" ] 2>/dev/null ; then
	ati-one
		else
		if [ `cat ~/.atiscript/version` == "\"$atwo"\" ] 2>/dev/null ; then
			ati-two
				else
				if [ `cat ~/.atiscript/version` == "\"$athree"\" ] 2>/dev/null ; then
					ati-three
						else
						if [ `cat ~/.atiscript/version` == "\"$afour"\" ] 2>/dev/null ; then
							ati-run
						else
							dialog --title "*ERROR*" --backtitle "atiscript $version" --msgbox "       UNEXPECTED ERROR OR GOOD BYE :)" 5 50
							exit
						fi
				fi
		fi	
fi
ati-make			
ati-ready




